
#ifndef _FALSEPOSMSG_H
#define _FALSEPOSMSG_H

#include <AM.h>

#define DEBUG

// All times in ms unless otherwise noted
enum {
	TX_ID = 0,
	PSM_STATE = 3,
	NO_PSM_STATE = 0,
	TEST_RUN_TIME = (1 * 120000L), 
	TIME_BUF_LEN = 128
};

enum {
	NO_CTRL = 0,
	SET_VALS = 1
};

//#define TX_EVENT_STR "TX_EVENT"
//#define RX_EVENT_STR "RX_EVENT"

enum {
	AM_UARTCTRLMSG = 77,
	AM_DUMMYMSG = 78,
	AM_STATSMSG = 79
};

// Make a max-sized dummy msg
typedef struct DummyMsg {
	uint8_t dummy[TOSH_DATA_LENGTH];
} __attribute__ ((packed)) DummyMsg;

typedef DummyMsg *DummyMsgPtr;

typedef struct UartCtrlMsg {
	uint8_t ctrlType;
	uint8_t senseTimeVal;
	uint8_t runSeqno;
} __attribute__ ((packed)) UartCtrlMsg;

typedef UartCtrlMsg *UartCtrlMsgPtr;

typedef struct StatsMsg {
	uint16_t nodeId;
	uint8_t fracIdle; // 0=0%, 255=100%, uniform spacing between
	uint8_t fracBusy; // 0=0%, 255=100%, uniform spacing between
	uint8_t runSeqno;
} __attribute__ ((packed)) StatsMsg;

typedef StatsMsg *StatsMsgPtr;

#endif

