#!/usr/bin/perl

$DEBUG = 0;

$append = 0;

if ($#ARGV != 1 && $#ARGV != 2) {
	die "Improper number of arguments\n";
}

if($#ARGV == 2) {
	if($ARGV[2] eq "-a") {
		$append = 1;
	}
	else {
		die "Optional Arguments: -a (append)\n";
	}
}

open (IN,"$ARGV[0]") || die "Cannot open $ARGV[0]\n";

if($append == 1) {
	open (OUT,">>$ARGV[1]") || die "Cannot open $ARGV[1]\n";
}
else {
	open (OUT,">$ARGV[1]") || die "Cannot open $ARGV[1]\n";
}

sub my_print {

	print OUT $_[0];
	print $_[0];

}

$pkt_drops = 0;
$pkts_sent = 0;
$pkts_recv = 0;
$bytes_sent = 0;
$bytes_recv = 0;

$start_time = -1;
$finish_time = -1;
$total_lat = 0;
%pkt_start;
%pkt_end;
%initial_enery;
%final_energy;

%pkt_path;

$end_drops = 0;
$col_drops = 0;
$all_col_drops = 0;
$dup_drops = 0;
$err_drops = 0;
$ret_drops = 0;
$sta_drops = 0;
$bsy_drops = 0;
$nrte_drops = 0;
$loop_drops = 0;
$ttl_drops = 0;
$tout_drops = 0;
$cbk_drops = 0;
$ifq_drops = 0;
$arp_drops = 0;
$out_drops = 0;
$mac_drops = 0;
$low_drops = 0;
$other_drops = 0;

#$tmp = time;
#print "time: $tmp\n";

$i = 0;
while (<IN>) {

#	if (@line != 12) {
#		next;
#	}

	# no match return ""
	(my $event) = /^(\w)\s+/;
	(my $time) = /.-t\s+(\d+\.\d+)\s+/;
	(my $pkt_type) = /.-(?:I|M)t\s+(\w+)\s+/;
	(my $pkt_level) = /.-Nl\s+(\w+)\s+/;
	(my $pkt_id) = /.-Ii\s+(\d+)\s+/;
	(my $num_bytes) = /.-Il\s+(\d+)\s+/;
	(my $node_id) = /.-Ni\s+(\d+)\s+/;
	(my $ip_src) = /.-Is\s+(\d+)\.\d+\s+/;
	(my $ip_dst) = /.-Id\s+(\d+)\.\d+\s+/;
	(my $drop_type) = /.-Nw\s+(\w+)\s+/;
	(my $energy) = /.-Ne\s+(\d+\.\d+)\s+/;

	if($DEBUG > 0 && $i < 50) {
		print "line: $_\n";
		print "event: $event\n";
		print "type: $pkt_type\n";
		print "time: $time\n";
		print "level: $pkt_level\n";
		print "id: $pkt_id\n";
	}
	$i++;

	if($event eq "M") {
		next;
	}

	if($node_id ne "" &&  $energy ne "" && 
			!(defined $initial_energy{$node_id})) {
		$initial_energy{$node_id} = $energy;
	}

	if($node_id ne "" &&  $energy ne "") {
		$final_energy{$node_id} = $energy;
	}

	if($start_time == -1) {
		$start_time = $time;
	}
	$finish_time = $time;

	$is_data = ($pkt_type eq "cbr" || $pkt_type eq "tcp" || 
			$pkt_type eq "exp");

	if($event eq "d" && $drop_type eq "COL") {
			$all_col_drops++;
	}

#	if($event eq "d" && $is_data && $pkt_level ne "MAC") {
	if($event eq "d" && $is_data) {
		# Count data packets dropped
		# For some reason, occasionally, the trace file will drop
		# a pkt at the sender after the receiver has already gotten
		# it due to CBK, we'll just ignore these
		if(!(defined $pkt_finish{$pkt_id})) {
			$pkt_drops++;

		# For some of the MAC layer drop times, we will decrement
		# the drop count so it does not get counted in our total.
		# E.g., DUP and COL show up in the trace, but do not affect
		# packet delivery, however, RET (retry) would signify a 
		# data packet has been permenantly dropped.
		if($drop_type eq "END") {
			$end_drops++;
		}
		elsif($drop_type eq "COL") {
			$col_drops++;
			$pkt_drops--;
		}
		elsif($drop_type eq "DUP") {
			$dup_drops++;
			$pkt_drops--;
		}
		elsif($drop_type eq "ERR") {
			$err_drops++;
		}
		elsif($drop_type eq "RET") {
			$ret_drops++;
		}
		elsif($drop_type eq "STA") {
			$sta_drops++;
		}
		elsif($drop_type eq "BSY") {
			$bsy_drops++;
		}
		elsif($drop_type eq "NRTE") {
			$nrte_drops++;
		}
		elsif($drop_type eq "LOOP") {
			$loop_drops++;
		}
		elsif($drop_type eq "TTL") {
			$ttl_drops++;
		}
		elsif($drop_type eq "TOUT") {
			$tout_drops++;
		}
		elsif($drop_type eq "CBK") {
			$cbk_drops++;
		}
		elsif($drop_type eq "IFQ" || 
				($pkt_level eq "IFQ" && $drop_type eq "---")) {
			$ifq_drops++;
		}
		elsif($drop_type eq "ARP") {
			$arp_drops++;
		}	
		elsif($drop_type eq "OUT") {
			$out_drops++;
		}	
		elsif($pkt_level eq "MAC") {
			$mac_drops++;
		}
		elsif($drop_type eq "LOW") {
			$low_drops++;
		}	
		else {
			$other_drops++;
		}
		}
	}

	if($event eq "s" && $is_data && $pkt_level eq "AGT") {
		$pkts_sent++;
		$bytes_sent += $num_bytes;

		$pkt_start{$pkt_id} = $time; 

		if($DEBUG > 0) {
			$pkt_path{$pkt_id}[0] = $node_id;
		}
	}

	if($DEBUG > 0) {
		if($event eq "f" && $is_data && $pkt_level eq "RTR") {
			push(@{$pkt_path{$pkt_id}}, $node_id);
		}
	}

	if($event eq "r" && $is_data && $pkt_level eq "AGT") {

		$pkts_recv++;
		$pkt_finish{$pkt_id} = $time; 
		$total_lat += $pkt_finish{$pkt_id} - $pkt_start{$pkt_id};

		if($DEBUG > 0) {
			$diff = $pkt_finish{$pkt_id} - $pkt_start{$pkt_id};
			my_print "pkt_id: $pkt_id, start_time: $pkt_start{$pkt_id},". 
				" finish_time: $pkt_finish{$pkt_id}, latency: $diff";
			push(@{$pkt_path{$pkt_id}}, $node_id);
			my_print " path: ";
			foreach $i (@{$pkt_path{$pkt_id}}) {
				my_print "$i ";
			}
			my_print "\n";
		}

		# For some reason, this does not remove the IP header bytes
		$bytes_recv += ($num_bytes - 20);
	}

}

$sim_time = -1.0;
my_print "\n";
if($start_time > -1 && $finish_time > -1 && $finish_time > $start_time) {
	$sim_time = sprintf("%.6f", ($finish_time - $start_time));
	my_print "simulation time: $sim_time\n";
	$goodput = ((8*$bytes_recv)/($finish_time-$start_time))/1000;
	$goodput = sprintf("%.6f", $goodput);;
	my_print "goodput: $goodput kpbs\n";
}

my_print "data packet drops: $pkt_drops\n";

$del_frac = -1.0;
if($pkts_sent > 0) {
 	$del_frac = sprintf("%.6f", (1.0 - ($pkt_drops/$pkts_sent)));
}
my_print "delivery fraction: $del_frac\n";

my_print "data sent: $pkts_sent pkts, $bytes_sent bytes\n";
my_print "data recv: $pkts_recv pkts, $bytes_recv bytes\n";

$avg_lat = -1.0;
if($pkts_recv > 0) {
	$avg_lat = sprintf("%.6f", (1000*($total_lat / $pkts_recv)));
}
$total_lat = sprintf("%.6f", $total_lat);
my_print "average per packet latency: $avg_lat ms\n";

$avg_energy_used = -1.0;
$num_nodes = 0;;
$total_energy_used = 0;
while ((my $node_id, my $i_energy) = each(%initial_energy)) {
	if(defined (my $f_energy = $final_energy{$node_id}) &&
			$i_energy >= $f_energy) {
		$total_energy_used += ($i_energy - $f_energy);
		$num_nodes++;
	}
}
if($num_nodes > 0) {
	$avg_energy_used = sprintf("%.6f", ($total_energy_used / $num_nodes));
}
my_print "average energy used per node: $avg_energy_used J\n";

$jpp = -1.0; # Joulse per packet
if($pkts_recv > 0) {
	$jpp = sprintf("%.6f", ($total_energy_used / $pkts_recv));
}
my_print "Joules per packet: $jpp\n";

$jpb = -1.0; # Joulse per bit
if($bytes_recv > 0) {
	$jpb = sprintf("%.9f", ($total_energy_used / (8*$bytes_recv)));
}
my_print "Joules per bit: $jpb\n";

$bpj = -1.0; # Bits per Joule
if($total_energy_used > 0) {
	$bpj = sprintf("%.6f", ((8 * $bytes_recv) / $total_energy_used));
}
my_print "bits delivered per Joule: $bpj\n";

if($pkt_drops > 0) {
	my_print "data drop types:\n";

	if($end_drops > 0) {
		my_print "\tEND: $end_drops\n";
	}
	if($col_drops > 0) {
		my_print "\tCOL: $col_drops\n";
	}
	if($dup_drops > 0) {
		my_print "\tDUP: $dup_drops\n";
	}
	if($err_drops > 0) {
		my_print "\tERR: $err_drops\n";
	}
	if($ret_drops > 0) {
		my_print "\tRET: $ret_drops\n";
	}
	if($sta_drops > 0) {
		my_print "\tSTA: $sta_drops\n";
	}
	if($bsy_drops > 0) {
		my_print "\tBSY: $bsy_drops\n";
	}
	if($ntre_drops > 0) {
		my_print "\tNTRE: $ntre_drops\n";
	}
	if($loop_drops > 0) {
		my_print "\tLOOP: $loop_drops\n";
	}
	if($ttl_drops > 0) {
		my_print "\tTTL: $ttl_drops\n";
	}
	if($tout_drops > 0) {
		my_print "\tTOUT: $tout_drops\n";
	}
	if($cbk_drops > 0) {
		my_print "\tCBK: $cbk_drops\n";
	}
	if($ifq_drops > 0) {
		my_print "\tIFQ: $ifq_drops\n";
	}
	if($arp_drops > 0) {
		my_print "\tARP: $arp_drops\n";
	}
	if($out_drops > 0) {
		my_print "\tOUT: $out_drops\n";
	}
	if($mac_drops > 0) {
		my_print "\tMAC: $mac_drops\n";
	}
	if($low_drops > 0) {
		my_print "\tLOW: $low_drops\n";
	}
	if($other_drops > 0) {
		my_print "\tOTHER: $other_drops\n";
	}

}

if($all_col_drops > 0) {
	my_print "\tALL COL: $all_col_drops\n";
}

my_print "\n";

close(OUT);
close(IN);

