
#ifndef _PBBFCONST_H
#define _PBBFCONST_H

enum {
	DEFAULT_PS_LEVEL = 3, 
	MAX_MAC_RETRANSMIT_LIMIT = 10
};

enum {
	PBBF_NUM_LEVELS=11
};

/* 
 * PBBF Parameters Table
 *
 * NOTE: To save RAM space, this table resides in program memory (flash). 
 * This has two important implications:
 *	1) You can't write to it (duh!)
 *	2) You must read it using the PRG_RDB(addr) macro. IT CANNOT BE ACCESSED AS AN ORDINARY C ARRAY.  
 * 
 */

// These numbers assume that the MAX value for the random number
// generator is an unsigned 16 bit int (0xFFFF)
static const prog_uchar PBBF_CMP_VAL[PBBF_NUM_LEVELS*2] = {
	0, 0, // 0 (0.0)
	0x19, 0x99, // 6553 (0.1)
	0x33, 0x32, // 13106 (0.2)
	0x4C, 0xCB, // 19659 (0.3)
	0x66, 0x64, // 26212 (0.4)
	0x7F, 0xFD, // 32765 (0.5)
	0x99, 0x96, // 39318 (0.6)
	0xB3, 0x2F, // 45871 (0.7)
	0xCC, 0xC8, // 52424 (0.8)
	0xE6, 0x61, // 58977 (0.9)
	0xFF, 0xFF // 65535 (1.0)
};

#endif /* _PBBFCONST_H */
